Scala Standard Library2.13.5 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection
  Definition Classes
    scala
-  package immutable
  Definition Classes
    collection
- ::
- AbstractMap
- AbstractSeq
- AbstractSet
- ArraySeq
- BitSet
- HashMap
- HashSet
- IndexedSeq
- IndexedSeqDefaults
- IndexedSeqOps
- IntMap
- Iterable
- LazyList
- LinearSeq
- LinearSeqOps
- List
- ListMap
- ListSet
- LongMap
- Map
- MapOps
- Nil
- NumericRange
- Queue
- Range
- Seq
- SeqMap
- SeqOps
- Set
- SetOps
- SortedMap
- SortedMapOps
- SortedSet
- SortedSetOps
- Stream
- StrictOptimizedMapOps
- StrictOptimizedSeqOps
- StrictOptimizedSetOps
- StrictOptimizedSortedMapOps
- StrictOptimizedSortedSetOps
- TreeMap
- TreeSeqMap
- TreeSet
- Vector
- VectorBuilder
- VectorMap
- WrappedString

o

scala.collection.immutable

# Nil

###

#### case object Nil extends List[Nothing] with Product with Serializable

Source
  List.scala

Linear Supertypes
Product, List[Nothing], DefaultSerializable, java.io.Serializable, StrictOptimizedSeqOps[Nothing, List, List[Nothing]], StrictOptimizedLinearSeqOps[Nothing, List, List[Nothing]], collection.StrictOptimizedSeqOps[Nothing, List, List[Nothing]], StrictOptimizedIterableOps[Nothing, List, List[Nothing]], LinearSeq[Nothing], LinearSeqOps[Nothing, [X]List[X], List[Nothing]], collection.LinearSeq[Nothing], collection.LinearSeqOps[Nothing, [X]List[X], List[Nothing]], AbstractSeq[Nothing], Seq[Nothing], SeqOps[Nothing, [_]List[_], List[Nothing]], Iterable[Nothing], collection.AbstractSeq[Nothing], collection.Seq[Nothing], Equals, collection.SeqOps[Nothing, [_]List[_], List[Nothing]], PartialFunction[Int, Nothing], (Int) => Nothing, AbstractIterable[Nothing], collection.Iterable[Nothing], IterableFactoryDefaults[Nothing, [x]List[x]], IterableOps[Nothing, [_]List[_], List[Nothing]], IterableOnceOps[Nothing, [_]List[_], List[Nothing]], IterableOnce[Nothing], AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Nil
2. Product
3. List
4. DefaultSerializable
5. Serializable
6. StrictOptimizedSeqOps
7. StrictOptimizedLinearSeqOps
8. StrictOptimizedSeqOps
9. StrictOptimizedIterableOps
10. LinearSeq
11. LinearSeqOps
12. LinearSeq
13. LinearSeqOps
14. AbstractSeq
15. Seq
16. SeqOps
17. Iterable
18. AbstractSeq
19. Seq
20. Equals
21. SeqOps
22. PartialFunction
23. Function1
24. AbstractIterable
25. Iterable
26. IterableFactoryDefaults
27. IterableOps
28. IterableOnceOps
29. IterableOnce
30. AnyRef
31. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##: Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  final def ++[B >: Nothing](suffix: IterableOnce[B]): List[B]

   Alias for `concat`

   Alias for `concat`

   Definition Classes
     IterableOps
   Annotations
     @inline()
4.  final def ++:[B >: Nothing](prefix: IterableOnce[B]): List[B]

   Alias for `prependedAll`

   Alias for `prependedAll`

   Definition Classes
     SeqOps → IterableOps
   Annotations
     @inline()
5.  final def +:[B >: Nothing](elem: B): List[B]

   Alias for `prepended`.

   Alias for `prepended`.

   Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Definition Classes
     SeqOps
   Annotations
     @inline()
6.  final def :+[B >: Nothing](elem: B): List[B]

   Alias for `appended`

   Alias for `appended`

   Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Definition Classes
     SeqOps
   Annotations
     @inline()
7.  final def :++[B >: Nothing](suffix: IterableOnce[B]): List[B]

   Alias for `appendedAll`

   Alias for `appendedAll`

   Definition Classes
     SeqOps
   Annotations
     @inline()
8.  def ::[B >: Nothing](elem: B): List[B]

   Adds an element at the beginning of this list.

   Adds an element at the beginning of this list.

   elem

     the element to prepend.

   returns

     a list which contains `x` as first element and which continues with this list. Example:

         1 :: List(2, 3) = List(2, 3).::(1) = List(1, 2, 3)

   Definition Classes
     List
9.  def :::[B >: Nothing](prefix: List[B]): List[B]

   Adds the elements of a given list in front of this list.

   Adds the elements of a given list in front of this list.

   Example:

       List(1, 2) ::: List(3, 4) = List(3, 4).:::(List(1, 2)) = List(1, 2, 3, 4)

   prefix

     The list elements to prepend.

   returns

     a list resulting from the concatenation of the given list `prefix` and this list.

   Definition Classes
     List
10.  final def ==(arg0: Any): Boolean

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
11.  final def addString(b: mutable.StringBuilder): mutable.StringBuilder

    Appends all elements of this list to a string builder.

    Appends all elements of this list to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this list without any separator string.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        h: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      IterableOnceOps
    Annotations
      @inline()
12.  final def addString(b: mutable.StringBuilder, sep: String): mutable.StringBuilder

    Appends all elements of this list to a string builder using a separator string.

    Appends all elements of this list to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this list, separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      IterableOnceOps
    Annotations
      @inline()
13.  def addString(b: mutable.StringBuilder, start: String, sep: String, end: String): mutable.StringBuilder

    Appends all elements of this list to a string builder using start, end, and separator strings.

    Appends all elements of this list to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this list are separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b , "List(" , ", " , ")")
        res5: StringBuilder = List(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      IterableOnceOps
14.  def andThen[C](k: PartialFunction[Nothing, C]): PartialFunction[Int, C]

    Composes this partial function with another partial function that gets applied to results of this partial function.

    Composes this partial function with another partial function that gets applied to results of this partial function.

    Note that calling isDefinedAt on the resulting partial function may apply the first partial function and execute its side effect. It is highly recommended to call applyOrElse instead of isDefinedAt / apply for efficiency.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the domain of this partial function narrowed by other partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction
15.  def andThen[C](k: (Nothing) => C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    If the runtime type of the function is a `PartialFunction` then the other `andThen` method is used (note its cautions).

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the domain of this partial function, possibly narrowed by the specified function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1
16.  def appended[B >: Nothing](elem: B): List[B]

    A copy of this list with an element appended.

    A copy of this list with an element appended.

    Example:

        scala> val a = List(1)
        a: List[Int] = List(1)

        scala> val b = a :+ 2
        b: List[Int] = List(1, 2)

        scala> println(a)
        List(1)

    B

      the element type of the returned list.

    elem

      the appended element

    returns

      a new list consisting of all elements of this list followed by `value`.

    Definition Classes
      StrictOptimizedSeqOps → SeqOps
17.  def appendedAll[B >: Nothing](suffix: IterableOnce[B]): List[B]

    Returns a new list containing the elements from the left hand operand followed by the elements from the right hand operand.

    Returns a new list containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the list is the most specific superclass encompassing the element types of the two operands.

    B

      the element type of the returned collection.

    suffix

      the iterable to append.

    returns

      a new collection of type `CC[B]` which contains all elements of this list followed by all elements of `suffix`.

    Definition Classes
      List → StrictOptimizedSeqOps → SeqOps
18.  def apply(n: Int): Nothing

    Get the element at the specified index.

    Get the element at the specified index. This operation is provided for convenience in `Seq`. It should not be assumed to be efficient unless you have an `IndexedSeq`.

    Definition Classes
      LinearSeqOps → SeqOps
    Annotations
      @throws(cause = scala.this.throws.<init>$default$1[IndexOutOfBoundsException])
19.  def applyOrElse[A1 <: Int, B1 >: Nothing](x: A1, default: (A1) => B1): B1

    Applies this partial function to the given argument when it is contained in the function domain.

    Applies this partial function to the given argument when it is contained in the function domain. Applies fallback function where this partial function is not defined.

    Note that expression `pf.applyOrElse(x, default)` is equivalent to

        if(pf isDefinedAt x) pf(x) else default(x)

    except that `applyOrElse` method can be implemented more efficiently. For all partial function literals the compiler generates an `applyOrElse` implementation which avoids double evaluation of pattern matchers and guards. This makes `applyOrElse` the basis for the efficient implementation for many operations and scenarios, such as:

    - combining partial functions into `orElse`/`andThen` chains does not lead to excessive `apply`/`isDefinedAt` evaluation
    - `lift` and `unlift` do not evaluate source functions twice on each invocation
    - `runWith` allows efficient imperative-style combining of partial functions with conditionally applied actions

    For non-literal partial function classes with nontrivial `isDefinedAt` method it is recommended to override `applyOrElse` with custom implementation that avoids double `isDefinedAt` evaluation. This may result in better performance and more predictable behavior w.r.t. side effects.

    x

      the function argument

    default

      the fallback function

    returns

      the result of this function or fallback function application.

    Definition Classes
      PartialFunction
20.  final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

21.  def canEqual(that: Any): Boolean

    A method that should be called from every well-designed equals method that is open to be overridden in a subclass.

    A method that should be called from every well-designed equals method that is open to be overridden in a subclass. See Programming in Scala, Chapter 28 for discussion and design.

    that

      the value being probed for possible equality

    returns

      true if this instance can possibly equal `that`, otherwise false

    Definition Classes
      Seq → Equals
22.  def className: String

    Defines the prefix of this object's `toString` representation.

    Defines the prefix of this object's `toString` representation.

    It is recommended to return the name of the concrete collection type, but not implementation subclasses. For example, for `ListMap` this method should return `"ListMap"`, not `"Map"` (the supertype) or `"Node"` (an implementation subclass).

    The default implementation returns "Iterable". It is overridden for the basic collection kinds "Seq", "IndexedSeq", "LinearSeq", "Buffer", "Set", "Map", "SortedSet", "SortedMap" and "View".

    returns

      a string representation which starts the result of `toString` applied to this list. By default the string prefix is the simple name of the collection class list.

    Attributes
      protected[this]
    Definition Classes
      List → Iterable
23.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

24.  final def coll: Nil.this.type

    returns

      This collection as a `C`.

    Attributes
      protected
    Definition Classes
      Iterable → IterableOps
25.  final def collect[B](pf: PartialFunction[Nothing, B]): List[B]

    Builds a new list by applying a partial function to all elements of this list on which the function is defined.

    Builds a new list by applying a partial function to all elements of this list on which the function is defined.

    B

      the element type of the returned list.

    pf

      the partial function which filters and maps the list.

    returns

      a new list resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      List → StrictOptimizedIterableOps → IterableOps → IterableOnceOps
26.  def collectFirst[B](pf: PartialFunction[Nothing, B]): Option[B]

    Finds the first element of the list for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the list for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      IterableOnceOps
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

27.  def combinations(n: Int): Iterator[List[Nothing]]

    Iterates over combinations.

    Iterates over combinations. A _combination_ of length `n` is a subsequence of the original sequence, with the elements taken in order. Thus, `"xy"` and `"yy"` are both length-2 combinations of `"xyy"`, but `"yx"` is not. If there is more than one way to generate the same subsequence, only one will be returned.

    For example, `"xyyy"` has three different ways to generate `"xy"` depending on whether the first, second, or third `"y"` is selected. However, since all are identical, only one will be chosen. Which of the three will be taken is an implementation detail that is not defined.

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    returns

      An Iterator which traverses the possible n-element combinations of this list.

    Definition Classes
      SeqOps
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

28.  def compose[R](k: PartialFunction[R, Int]): PartialFunction[R, Nothing]

    Composes another partial function `k` with this partial function so that this partial function gets applied to results of `k`.

    Composes another partial function `k` with this partial function so that this partial function gets applied to results of `k`.

    Note that calling isDefinedAt on the resulting partial function may apply the first partial function and execute its side effect. It is highly recommended to call applyOrElse instead of isDefinedAt / apply for efficiency.

    R

      the parameter type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the domain of other partial function narrowed by this partial function, which maps arguments `x` to `this(k(x))`.

    Definition Classes
      PartialFunction
29.  def compose[A](g: (A) => Int): (A) => Nothing

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1
    Annotations
      @unspecialized()
30.  final def concat[B >: Nothing](suffix: IterableOnce[B]): List[B]

    Returns a new list containing the elements from the left hand operand followed by the elements from the right hand operand.

    Returns a new list containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the list is the most specific superclass encompassing the element types of the two operands.

    B

      the element type of the returned collection.

    suffix

      the traversable to append.

    returns

      a new list which contains all elements of this list followed by all elements of `suffix`.

    Definition Classes
      SeqOps → IterableOps
    Annotations
      @inline()
31.  final def contains[A1 >: Nothing](elem: A1): Boolean

    Tests whether this list contains a given value as an element.

    Tests whether this list contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this list has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

    Definition Classes
      List → LinearSeqOps → SeqOps
32.  def containsSlice[B >: Nothing](that: collection.Seq[B]): Boolean

    Tests whether this list contains a given sequence as a slice.

    Tests whether this list contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this list contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqOps
33.  def copyToArray[B >: Nothing](xs: Array[B], start: Int, len: Int): Int

    Copy elements to an array, returning the number of elements written.

    Copy elements to an array, returning the number of elements written.

    Fills the given array `xs` starting at index `start` with at most `len` elements of this list.

    Copying will stop once either all the elements of this list have been copied, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index of xs.

    len

      the maximal number of elements to copy.

    returns

      the number of elements written to the array

    Definition Classes
      IterableOnceOps
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

34.  def copyToArray[B >: Nothing](xs: Array[B], start: Int): Int

    Copy elements to an array, returning the number of elements written.

    Copy elements to an array, returning the number of elements written.

    Fills the given array `xs` starting at index `start` with values of this list.

    Copying will stop once either all the elements of this list have been copied, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index of xs.

    returns

      the number of elements written to the array

    Definition Classes
      IterableOnceOps
    Annotations
      @deprecatedOverriding(message = "This should always forward to the 3-arg version of this method", since = "2.13.4")
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

35.  def copyToArray[B >: Nothing](xs: Array[B]): Int

    Copy elements to an array, returning the number of elements written.

    Copy elements to an array, returning the number of elements written.

    Fills the given array `xs` starting at index `start` with values of this list.

    Copying will stop once either all the elements of this list have been copied, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    returns

      the number of elements written to the array

    Definition Classes
      IterableOnceOps
    Annotations
      @deprecatedOverriding(message = "This should always forward to the 3-arg version of this method", since = "2.13.4")
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

36.  def corresponds[B](that: collection.Seq[B])(p: (Nothing, B) => Boolean): Boolean

    Tests whether every element of this list relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this list relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this list and `y` of `that`, otherwise `false`.

    Definition Classes
      List → SeqOps
37.  def corresponds[B](that: IterableOnce[B])(p: (Nothing, B) => Boolean): Boolean

    Tests whether every element of this collection's iterator relates to the corresponding element of another collection by satisfying a test predicate.

    Tests whether every element of this collection's iterator relates to the corresponding element of another collection by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other collection

    p

      the test predicate, which relates elements from both collections

    returns

      `true` if both collections have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this iterator and `y` of `that`, otherwise `false`

    Definition Classes
      IterableOnceOps
38.  def count(p: (Nothing) => Boolean): Int

    Counts the number of elements in the list which satisfy a predicate.

    Counts the number of elements in the list which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      IterableOnceOps
39.  def diff[B >: Nothing](that: collection.Seq[B]): List[Nothing]

    Computes the multiset difference between this list and another sequence.

    Computes the multiset difference between this list and another sequence.

    that

      the sequence of elements to remove

    returns

      a new list which contains all elements of this list except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      StrictOptimizedSeqOps → SeqOps
40.  def distinct: List[Nothing]

    Selects all the elements of this list ignoring the duplicates.

    Selects all the elements of this list ignoring the duplicates.

    returns

      a new list consisting of all the elements of this list without duplicates.

    Definition Classes
      SeqOps
41.  def distinctBy[B](f: (Nothing) => B): List[Nothing]

    Selects all the elements of this list ignoring the duplicates as determined by `==` after applying the transforming function `f`.

    Selects all the elements of this list ignoring the duplicates as determined by `==` after applying the transforming function `f`.

    B

      the type of the elements after being transformed by `f`

    f

      The transforming function whose result is used to determine the uniqueness of each element

    returns

      a new list consisting of all the elements of this list without duplicates.

    Definition Classes
      StrictOptimizedSeqOps → StrictOptimizedSeqOps → SeqOps
42.  def drop(n: Int): List[Nothing]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this list.

    returns

      a list consisting of all elements of this list except the first `n` ones, or else the empty list, if this list has less than `n` elements. If `n` is negative, don't drop any elements.

    Definition Classes
      StrictOptimizedLinearSeqOps → IterableOps → IterableOnceOps
43.  def dropRight(n: Int): List[Nothing]

    The rest of the collection without its `n` last elements.

    The rest of the collection without its `n` last elements. For linear, immutable collections this should avoid making a copy.

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    n

      the number of elements to drop from this list.

    returns

      a list consisting of all elements of this list except the last `n` ones, or else the empty list, if this list has less than `n` elements. If `n` is negative, don't drop any elements.

    Definition Classes
      StrictOptimizedIterableOps → IterableOps
44.  def dropWhile(p: (Nothing) => Boolean): List[Nothing]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this list whose first element does not satisfy the predicate `p`.

    Definition Classes
      StrictOptimizedLinearSeqOps → IterableOps → IterableOnceOps
45.  def elementWise: ElementWiseExtractor[Int, Nothing]

    Returns an extractor object with a `unapplySeq` method, which extracts each element of a sequence data.

    Returns an extractor object with a `unapplySeq` method, which extracts each element of a sequence data.

    Definition Classes
      PartialFunction
    Example:

    1.     val firstChar: String => Option[Char] = _.headOption

           Seq("foo", "bar", "baz") match {
             case firstChar.unlift.elementWise(c0, c1, c2) =>
               println(s"$c0, $c1, $c2") // Output: f, b, b
           }

46.  def empty: List[Nothing]

    The empty iterable of the same type as this iterable

    The empty iterable of the same type as this iterable

    returns

      an empty iterable of type `C`.

    Definition Classes
      IterableFactoryDefaults → IterableOps
47.  def endsWith[B >: Nothing](that: collection.Iterable[B]): Boolean

    Tests whether this list ends with the given sequence.

    Tests whether this list ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this list has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqOps
48.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
49.  def equals(o: Any): Boolean

    The universal equality method defined in `AnyRef`.

    The universal equality method defined in `AnyRef`.

    Definition Classes
      List → Seq → Equals → AnyRef → Any
50.  final def exists(p: (Nothing) => Boolean): Boolean

    Tests whether a predicate holds for at least one element of this list.

    Tests whether a predicate holds for at least one element of this list.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` is satisfied by at least one element of this list, otherwise `false`

    Definition Classes
      List → LinearSeqOps → IterableOnceOps
51.  def filter(p: (Nothing) => Boolean): List[Nothing]

    Selects all elements of this list which satisfy a predicate.

    Selects all elements of this list which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new iterator consisting of all elements of this list that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      List → StrictOptimizedIterableOps → IterableOps → IterableOnceOps
52.  def filterImpl(pred: (Nothing) => Boolean, isFlipped: Boolean): List[Nothing]
    Attributes
      protected[collection]
    Definition Classes
      StrictOptimizedIterableOps
53.  def filterNot(p: (Nothing) => Boolean): List[Nothing]

    Selects all elements of this list which do not satisfy a predicate.

    Selects all elements of this list which do not satisfy a predicate.

    returns

      a new list consisting of all elements of this list that do not satisfy the given predicate `pred`. Their order may not be preserved.

    Definition Classes
      List → StrictOptimizedIterableOps → IterableOps → IterableOnceOps
54.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

55.  final def find(p: (Nothing) => Boolean): Option[Nothing]

    Finds the first element of the list satisfying a predicate, if any.

    Finds the first element of the list satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the list that satisfies `p`, or `None` if none exists.

    Definition Classes
      List → LinearSeqOps → IterableOnceOps
56.  def findLast(p: (Nothing) => Boolean): Option[Nothing]

    Finds the last element of the list satisfying a predicate, if any.

    Finds the last element of the list satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the last element in the list that satisfies `p`, or `None` if none exists.

    Definition Classes
      LinearSeqOps → SeqOps
57.  final def flatMap[B](f: (Nothing) => IterableOnce[B]): List[B]

    Builds a new list by applying a function to all elements of this list and using the elements of the resulting collections.

    Builds a new list by applying a function to all elements of this list and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of list. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap ((word: String) => word.toSeq)

        // xs will be an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new list resulting from applying the given collection-valued function `f` to each element of this list and concatenating the results.

    Definition Classes
      List → StrictOptimizedIterableOps → IterableOps → IterableOnceOps
58.  def flatten[B](implicit toIterableOnce: (Nothing) => IterableOnce[B]): List[B]

    Converts this list of traversable collections into a list formed by the elements of these traversable collections.

    Converts this list of traversable collections into a list formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the type of list. For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(1, 2, 3)
                 ).flatten
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(
                   List(1, 2, 3),
                   List(3, 2, 1)
                 ).flatten
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new list resulting from concatenating all element lists.

    Definition Classes
      StrictOptimizedIterableOps → IterableOps → IterableOnceOps
59.  def fold[A1 >: Nothing](z: A1)(op: (A1, A1) => A1): A1

    Folds the elements of this list using the specified associative binary operator.

    Folds the elements of this list using the specified associative binary operator. The default implementation in `IterableOnce` is equivalent to `foldLeft` but may be overridden for more efficient traversal orders.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication).

    op

      a binary operator that must be associative.

    returns

      the result of applying the fold operator `op` between all the elements and `z`, or `z` if this list is empty.

    Definition Classes
      IterableOnceOps
60.  def foldLeft[B](z: B)(op: (B, Nothing) => B): B

    Applies a binary operator to a start value and all elements of this list, going left to right.

    Applies a binary operator to a start value and all elements of this list, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this list, going left to right with the start value `z` on the left: `op(...op(z, x1), x2, ..., xn)` where `x1, ..., xn` are the elements of this list. Returns `z` if this list is empty.

    Definition Classes
      LinearSeqOps → IterableOnceOps
61.  final def foldRight[B](z: B)(op: (Nothing, B) => B): B

    Applies a binary operator to all elements of this list and a start value, going right to left.

    Applies a binary operator to all elements of this list and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this list, going right to left with the start value `z` on the right: `op(x1, op(x2, ... op(xn, z)...))` where `x1, ..., xn` are the elements of this list. Returns `z` if this list is empty.

    Definition Classes
      List → IterableOnceOps
62.  final def forall(p: (Nothing) => Boolean): Boolean

    Tests whether a predicate holds for all elements of this list.

    Tests whether a predicate holds for all elements of this list.

    p

      the predicate used to test elements.

    returns

      `true` if this list is empty or the given predicate `p` holds for all elements of this list, otherwise `false`.

    Definition Classes
      List → LinearSeqOps → IterableOnceOps
63.  final def foreach[U](f: (Nothing) => U): Unit

    Apply `f` to each element for its side effects Note: [U] parameter needed to help scalac's type inference.

    Apply `f` to each element for its side effects Note: [U] parameter needed to help scalac's type inference.

    Definition Classes
      List → LinearSeqOps → IterableOnceOps
    Annotations
      @inline()
64.  def fromSpecific(coll: IterableOnce[Nothing]): List[Nothing]

    Defines how to turn a given `Iterable[A]` into a collection of type `C`.

    Defines how to turn a given `Iterable[A]` into a collection of type `C`.

    This process can be done in a strict way or a non-strict way (ie. without evaluating the elements of the resulting collections). In other words, this methods defines the evaluation model of the collection.

    Attributes
      protected
    Definition Classes
      IterableFactoryDefaults → IterableOps
    Note

      When implementing a custom collection type and refining `C` to the new type, this method needs to be overridden (the compiler will issue an error otherwise). In the common case where `C =:= CC[A]`, this can be done by mixing in the scala.collection.IterableFactoryDefaults trait, which implements the method using iterableFactory.

      ,

      As witnessed by the `@uncheckedVariance` annotation, using this method might be unsound. However, as long as it is called with an `Iterable[A]` obtained from `this` collection (as it is the case in the implementations of operations where we use a `View[A]`), it is safe.

65.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
66.  def groupBy[K](f: (Nothing) => K): Map[K, List[Nothing]]

    Partitions this list into a map of lists according to some discriminator function.

    Partitions this list into a map of lists according to some discriminator function.

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to lists such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a list of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      IterableOps
67.  def groupMap[K, B](key: (Nothing) => K)(f: (Nothing) => B): Map[K, List[B]]

    Partitions this list into a map of lists according to a discriminator function `key`.

    Partitions this list into a map of lists according to a discriminator function `key`. Each element in a group is transformed into a value of type `B` using the `value` function.

    It is equivalent to `groupBy(key).mapValues(_.map(f))`, but more efficient.

        case class User(name: String, age: Int)

        def namesByAge(users: Seq[User]): Map[Int, Seq[String]] =
          users.groupMap(_.age)(_.name)

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    K

      the type of keys returned by the discriminator function

    B

      the type of values returned by the transformation function

    key

      the discriminator function

    f

      the element transformation function

    Definition Classes
      IterableOps
68.  def groupMapReduce[K, B](key: (Nothing) => K)(f: (Nothing) => B)(reduce: (B, B) => B): Map[K, B]

    Partitions this list into a map according to a discriminator function `key`.

    Partitions this list into a map according to a discriminator function `key`. All the values that have the same discriminator are then transformed by the `f` function and then reduced into a single value with the `reduce` function.

    It is equivalent to `groupBy(key).mapValues(_.map(f).reduce(reduce))`, but more efficient.

        def occurrences[A](as: Seq[A]): Map[A, Int] =
          as.groupMapReduce(identity)(_ => 1)(_ + _)

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    Definition Classes
      IterableOps
69.  def grouped(size: Int): Iterator[List[Nothing]]

    Partitions elements in fixed size lists.

    Partitions elements in fixed size lists.

    size

      the number of elements per group

    returns

      An iterator producing lists of size `size`, except the last will be less than size `size` if the elements don't divide evenly.

    Definition Classes
      IterableOps
    See also

      scala.collection.Iterator, method `grouped`

70.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      Seq → AnyRef → Any
71.  def head: Nothing

    Selects the first element of this list.

    Selects the first element of this list.

    returns

      the first element of this list.

    Definition Classes
      Nil → LinearSeqOps → IterableOps
    Exceptions thrown

      `NoSuchElementException` if the list is empty.

72.  def headOption: None.type

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this list if it is nonempty, `None` if it is empty.

    Definition Classes
      Nil → LinearSeqOps → IterableOps
73.  def indexOf[B >: Nothing](elem: B): Int

    Finds index of first occurrence of some value in this list.

    Finds index of first occurrence of some value in this list.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index `>= 0` of the first element of this list that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      SeqOps
    Annotations
      @deprecatedOverriding(message = "Override indexOf(elem, from) instead - indexOf(elem) calls indexOf(elem, 0)", since = "2.13.0")
74.  def indexOf[B >: Nothing](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this list after or at some start index.

    Finds index of first occurrence of some value in this list after or at some start index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this list that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      SeqOps
75.  def indexOfSlice[B >: Nothing](that: collection.Seq[B]): Int

    Finds first index where this list contains a given sequence as a slice.

    Finds first index where this list contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index `>= 0` such that the elements of this list starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqOps
    Annotations
      @deprecatedOverriding(message = "Override indexOfSlice(that, from) instead - indexOfSlice(that) calls indexOfSlice(that, 0)", since = "2.13.0")
76.  def indexOfSlice[B >: Nothing](that: collection.Seq[B], from: Int): Int

    Finds first index after or at a start index where this list contains a given sequence as a slice.

    Finds first index after or at a start index where this list contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this list starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqOps
77.  def indexWhere(p: (Nothing) => Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this list that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      LinearSeqOps → SeqOps
78.  def indexWhere(p: (Nothing) => Boolean): Int

    Finds index of the first element satisfying some predicate.

    Finds index of the first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index `>= 0` of the first element of this list that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqOps
    Annotations
      @deprecatedOverriding(message = "Override indexWhere(p, from) instead - indexWhere(p) calls indexWhere(p, 0)", since = "2.13.0")
79.  def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    returns

      a `Range` value from `0` to one less than the length of this list.

    Definition Classes
      SeqOps
80.  def init: Nothing

    The initial part of the collection without its last element.

    The initial part of the collection without its last element.

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    Definition Classes
      Nil → IterableOps
81.  def inits: Iterator[List[Nothing]]

    Iterates over the inits of this list.

    Iterates over the inits of this list. The first value will be this list and the final one will be an empty list, with the intervening values the results of successive applications of `init`.

    Note: Even when applied to a view or a lazy collection it will always force the elements.

    returns

      an iterator over all the inits of this list

    Definition Classes
      IterableOps
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

82.  def intersect[B >: Nothing](that: collection.Seq[B]): List[Nothing]

    Computes the multiset intersection between this list and another sequence.

    Computes the multiset intersection between this list and another sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new list which contains all elements of this list which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      StrictOptimizedSeqOps → SeqOps
83.  def isDefinedAt(x: Int): Boolean

    Tests whether this list contains given index.

    Tests whether this list contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    returns

      `true` if this list contains an element at position `idx`, `false` otherwise.

    Definition Classes
      LinearSeqOps → SeqOps
84.  final def isEmpty: Boolean

    Tests whether the list is empty.

    Tests whether the list is empty.

    Note: Implementations in subclasses that are not repeatedly traversable must take care not to consume any elements when `isEmpty` is called.

    returns

      `true` if the list contains no elements, `false` otherwise.

    Definition Classes
      List → LinearSeqOps → SeqOps → IterableOnceOps
85.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
86.  def isTraversableAgain: Boolean

    Tests whether this list can be repeatedly traversed.

    Tests whether this list can be repeatedly traversed. Always true for Iterables and false for Iterators unless overridden.

    returns

      `true` if it is repeatedly traversable, `false` otherwise.

    Definition Classes
      IterableOps → IterableOnceOps
87.  def iterableFactory: SeqFactory[List]

    The companion object of this list, providing various factory methods.

    The companion object of this list, providing various factory methods.

    Definition Classes
      List → LinearSeq → LinearSeq → Seq → Iterable → Seq → Iterable → IterableOps
    Note

      When implementing a custom collection type and refining `CC` to the new type, this method needs to be overridden to return a factory for the new type (the compiler will issue an error otherwise).

88.  def iterator: Iterator[Nothing]

    Iterator can be used only once

    Iterator can be used only once

    Definition Classes
      Nil → StrictOptimizedLinearSeqOps → LinearSeqOps → IterableOnce
89.  def knownSize: Int

    returns

      The number of elements in this list, if it can be cheaply computed, -1 otherwise. Cheaply usually means: Not requiring a collection traversal.

    Definition Classes
      Nil → IterableOnce
90.  def last: Nothing

    Selects the last element.

    Selects the last element.

    returns

      The last element of this list.

    Definition Classes
      Nil → List → LinearSeqOps → IterableOps
    Exceptions thrown

      `NoSuchElementException` If the list is empty.

91.  def lastIndexOf[B >: Nothing](elem: B, end: Int = length - 1): Int

    Finds index of last occurrence of some value in this list before or at a given end index.

    Finds index of last occurrence of some value in this list before or at a given end index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this list that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      SeqOps
92.  def lastIndexOfSlice[B >: Nothing](that: collection.Seq[B]): Int

    Finds last index where this list contains a given sequence as a slice.

    Finds last index where this list contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the last index such that the elements of this list starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqOps
    Annotations
      @deprecatedOverriding(message = "Override lastIndexOfSlice(that, end) instead - lastIndexOfSlice(that) calls lastIndexOfSlice(that, Int.MaxValue)", since = "2.13.0")
93.  def lastIndexOfSlice[B >: Nothing](that: collection.Seq[B], end: Int): Int

    Finds last index before or at a given end index where this list contains a given sequence as a slice.

    Finds last index before or at a given end index where this list contains a given sequence as a slice.

    that

      the sequence to test

    end

      the end index

    returns

      the last index `<= end` such that the elements of this list starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqOps
94.  def lastIndexWhere(p: (Nothing) => Boolean, end: Int): Int

    Finds index of last element satisfying some predicate before or at given end index.

    Finds index of last element satisfying some predicate before or at given end index.

    p

      the predicate used to test elements.

    returns

      the index `<= end` of the last element of this list that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      LinearSeqOps → SeqOps
95.  def lastIndexWhere(p: (Nothing) => Boolean): Int

    Finds index of last element satisfying some predicate.

    Finds index of last element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the last element of this list that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqOps
    Annotations
      @deprecatedOverriding(message = "Override lastIndexWhere(p, end) instead - lastIndexWhere(p) calls lastIndexWhere(p, Int.MaxValue)", since = "2.13.0")
96.  def lastOption: Option[Nothing]

    Optionally selects the last element.

    Optionally selects the last element.

    returns

      the last element of this list$ if it is nonempty, `None` if it is empty.

    Definition Classes
      IterableOps
97.  def lazyZip[B](that: collection.Iterable[B]): LazyZip2[Nothing, B, Nil.this.type]

    Analogous to `zip` except that the elements in each collection are not consumed until a strict operation is invoked on the returned `LazyZip2` decorator.

    Analogous to `zip` except that the elements in each collection are not consumed until a strict operation is invoked on the returned `LazyZip2` decorator.

    Calls to `lazyZip` can be chained to support higher arities (up to 4) without incurring the expense of constructing and deconstructing intermediary tuples.

        val xs = List(1, 2, 3)
        val res = (xs lazyZip xs lazyZip xs lazyZip xs).map((a, b, c, d) => a + b + c + d)
        // res == List(4, 8, 12)

    B

      the type of the second element in each eventual pair

    that

      the iterable providing the second element of each eventual pair

    returns

      a decorator `LazyZip2` that allows strict operations to be performed on the lazily evaluated pairs or chained calls to `lazyZip`. Implicit conversion to `Iterable[(A, B)]` is also supported.

    Definition Classes
      Iterable
98.  final def length: Int

    The length (number of elements) of the list.

    The length (number of elements) of the list. `size` is an alias for `length` in `Seq` collections.

    Definition Classes
      List → LinearSeqOps → SeqOps
99.  final def lengthCompare(len: Int): Int

    Compares the length of this list to a test value.

    Compares the length of this list to a test value.

    len

      the test value that gets compared with the length.

    returns

      A value `x` where

          x <  0       if this.length <  len
          x == 0       if this.length == len
          x >  0       if this.length >  len

      The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overridden if computing `length` is cheap and `knownSize` returns `-1`.

    Definition Classes
      List → LinearSeqOps → SeqOps
    See also

      lengthIs

100.  def lengthCompare(that: collection.Iterable[_]): Int

     Compares the length of this list to the size of another `Iterable`.

     Compares the length of this list to the size of another `Iterable`.

     that

       the `Iterable` whose size is compared with this list's length.

     returns

       A value `x` where

           x <  0       if this.length <  that.size
           x == 0       if this.length == that.size
           x >  0       if this.length >  that.size

       The method as implemented here does not call `length` or `size` directly; its running time is `O(this.length min that.size)` instead of `O(this.length + that.size)`. The method should be overridden if computing `size` is cheap and `knownSize` returns `-1`.

     Definition Classes
       LinearSeqOps → SeqOps
101.  final def lengthIs: SizeCompareOps

     Returns a value class containing operations for comparing the length of this list to a test value.

     Returns a value class containing operations for comparing the length of this list to a test value.

     These operations are implemented in terms of `lengthCompare(Int)`, and allow the following more readable usages:

         this.lengthIs < len     // this.lengthCompare(len) < 0
         this.lengthIs <= len    // this.lengthCompare(len) <= 0
         this.lengthIs == len    // this.lengthCompare(len) == 0
         this.lengthIs != len    // this.lengthCompare(len) != 0
         this.lengthIs >= len    // this.lengthCompare(len) >= 0
         this.lengthIs > len     // this.lengthCompare(len) > 0

     Definition Classes
       SeqOps
     Annotations
       @inline()
102.  def lift: (Int) => Option[Nothing]

     Turns this partial function into a plain function returning an `Option` result.

     Turns this partial function into a plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

103.  final def map[B](f: (Nothing) => B): List[B]

     Builds a new list by applying a function to all elements of this list.

     Builds a new list by applying a function to all elements of this list.

     B

       the element type of the returned list.

     f

       the function to apply to each element.

     returns

       a new list resulting from applying the given function `f` to each element of this list and collecting the results.

     Definition Classes
       List → StrictOptimizedIterableOps → IterableOps → IterableOnceOps
104.  final def mapConserve[B >: Nothing <: AnyRef](f: (Nothing) => B): List[B]

     Builds a new list by applying a function to all elements of this list.

     Builds a new list by applying a function to all elements of this list. Like `xs map f`, but returns `xs` unchanged if function `f` maps all elements to themselves (as determined by `eq`).

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a list resulting from applying the given function `f` to each element of this list and collecting the results.

     Definition Classes
       List
     Annotations
       @inline()
105.  def max[B >: Nothing](implicit ord: math.Ordering[B]): Nothing

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     ord

       An ordering to be used for comparing elements.

     returns

       the largest element of this list with respect to the ordering `ord`.

     Definition Classes
       IterableOnceOps
     Exceptions thrown

       `UnsupportedOperationException` if this list is empty.

106.  def maxBy[B](f: (Nothing) => B)(implicit cmp: math.Ordering[B]): Nothing

     Finds the first element which yields the largest value measured by function f.

     Finds the first element which yields the largest value measured by function f.

     B

       The result type of the function f.

     f

       The measuring function.

     cmp

       An ordering to be used for comparing elements.

     returns

       the first element of this list with the largest value measured by function f with respect to the ordering `cmp`.

     Definition Classes
       IterableOnceOps
     Exceptions thrown

       `UnsupportedOperationException` if this list is empty.

107.  def maxByOption[B](f: (Nothing) => B)(implicit cmp: math.Ordering[B]): Option[Nothing]

     Finds the first element which yields the largest value measured by function f.

     Finds the first element which yields the largest value measured by function f.

     B

       The result type of the function f.

     f

       The measuring function.

     cmp

       An ordering to be used for comparing elements.

     returns

       an option value containing the first element of this list with the largest value measured by function f with respect to the ordering `cmp`.

     Definition Classes
       IterableOnceOps
108.  def maxOption[B >: Nothing](implicit ord: math.Ordering[B]): Option[Nothing]

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     ord

       An ordering to be used for comparing elements.

     returns

       an option value containing the largest element of this list with respect to the ordering `ord`.

     Definition Classes
       IterableOnceOps
109.  def min[B >: Nothing](implicit ord: math.Ordering[B]): Nothing

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     ord

       An ordering to be used for comparing elements.

     returns

       the smallest element of this list with respect to the ordering `ord`.

     Definition Classes
       IterableOnceOps
     Exceptions thrown

       `UnsupportedOperationException` if this list is empty.

110.  def minBy[B](f: (Nothing) => B)(implicit cmp: math.Ordering[B]): Nothing

     Finds the first element which yields the smallest value measured by function f.

     Finds the first element which yields the smallest value measured by function f.

     B

       The result type of the function f.

     f

       The measuring function.

     cmp

       An ordering to be used for comparing elements.

     returns

       the first element of this list with the smallest value measured by function f with respect to the ordering `cmp`.

     Definition Classes
       IterableOnceOps
     Exceptions thrown

       `UnsupportedOperationException` if this list is empty.

111.  def minByOption[B](f: (Nothing) => B)(implicit cmp: math.Ordering[B]): Option[Nothing]

     Finds the first element which yields the smallest value measured by function f.

     Finds the first element which yields the smallest value measured by function f.

     B

       The result type of the function f.

     f

       The measuring function.

     cmp

       An ordering to be used for comparing elements.

     returns

       an option value containing the first element of this list with the smallest value measured by function f with respect to the ordering `cmp`.

     Definition Classes
       IterableOnceOps
112.  def minOption[B >: Nothing](implicit ord: math.Ordering[B]): Option[Nothing]

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     ord

       An ordering to be used for comparing elements.

     returns

       an option value containing the smallest element of this list with respect to the ordering `ord`.

     Definition Classes
       IterableOnceOps
113.  final def mkString: String

     Displays all elements of this list in a string.

     Displays all elements of this list in a string.

     Delegates to addString, which can be overridden.

     returns

       a string representation of this list. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this list follow each other without any separator string.

     Definition Classes
       IterableOnceOps
     Annotations
       @inline()
114.  final def mkString(sep: String): String

     Displays all elements of this list in a string using a separator string.

     Displays all elements of this list in a string using a separator string.

     Delegates to addString, which can be overridden.

     sep

       the separator string.

     returns

       a string representation of this list. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this list are separated by the string `sep`.

     Definition Classes
       IterableOnceOps
     Annotations
       @inline()
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

115.  final def mkString(start: String, sep: String, end: String): String

     Displays all elements of this list in a string using start, end, and separator strings.

     Displays all elements of this list in a string using start, end, and separator strings.

     Delegates to addString, which can be overridden.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this list. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this list are separated by the string `sep`.

     Definition Classes
       IterableOnceOps
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

116.  final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef
117.  def newSpecificBuilder: Builder[Nothing, List[Nothing]]

     returns

       a strict builder for the same collection type. Note that in the case of lazy collections (e.g. scala.collection.View or scala.collection.immutable.LazyList), it is possible to implement this method but the resulting `Builder` will break laziness. As a consequence, operations should preferably be implemented with `fromSpecific` instead of this method.

     Attributes
       protected
     Definition Classes
       IterableFactoryDefaults → IterableOps
     Note

       When implementing a custom collection type and refining `C` to the new type, this method needs to be overridden (the compiler will issue an error otherwise). In the common case where `C =:= CC[A]`, this can be done by mixing in the scala.collection.IterableFactoryDefaults trait, which implements the method using iterableFactory.

       ,

       As witnessed by the `@uncheckedVariance` annotation, using this method might be unsound. However, as long as the returned builder is only fed with `A` values taken from `this` instance, it is safe.

118.  def nonEmpty: Boolean

     Tests whether the list is not empty.

     Tests whether the list is not empty.

     returns

       `true` if the list contains at least one element, `false` otherwise.

     Definition Classes
       IterableOnceOps
     Annotations
       @deprecatedOverriding(message = "nonEmpty is defined as !isEmpty; override isEmpty instead", since = "2.13.0")
119.  final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Annotations
       @native()
     Note

       not specified by SLS as a member of AnyRef

120.  final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Annotations
       @native()
     Note

       not specified by SLS as a member of AnyRef

121.  def occCounts[B](sq: collection.Seq[B]): mutable.Map[B, Int]
     Attributes
       protected[collection]
     Definition Classes
       SeqOps
122.  def orElse[A1 <: Int, B1 >: Nothing](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction
123.  def padTo[B >: Nothing](len: Int, elem: B): List[B]

     A copy of this list with an element value appended until a given target length is reached.

     A copy of this list with an element value appended until a given target length is reached.

     B

       the element type of the returned list.

     len

       the target length

     elem

       the padding value

     returns

       a new list consisting of all elements of this list followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       StrictOptimizedSeqOps → SeqOps
124.  def partition(p: (Nothing) => Boolean): (List[Nothing], List[Nothing])

     A pair of, first, all elements that satisfy predicate `p` and, second, all elements that do not.

     A pair of, first, all elements that satisfy predicate `p` and, second, all elements that do not. Interesting because it splits a collection in two.

     The default implementation provided here needs to traverse the collection twice. Strict collections have an overridden version of `partition` in `StrictOptimizedIterableOps`, which requires only a single traversal.

     Definition Classes
       List → StrictOptimizedIterableOps → IterableOps
125.  def partitionMap[A1, A2](f: (Nothing) => Either[A1, A2]): (List[A1], List[A2])

     Applies a function `f` to each element of the list and returns a pair of lists: the first one made of those values returned by `f` that were wrapped in scala.util.Left, and the second one made of those wrapped in scala.util.Right.

     Applies a function `f` to each element of the list and returns a pair of lists: the first one made of those values returned by `f` that were wrapped in scala.util.Left, and the second one made of those wrapped in scala.util.Right.

     Example:

         val xs = `List`(1, "one", 2, "two", 3, "three") partitionMap {
          case i: Int => Left(i)
          case s: String => Right(s)
         }
         // xs == (`List`(1, 2, 3),
         //        `List`(one, two, three))

     A1

       the element type of the first resulting collection

     A2

       the element type of the second resulting collection

     f

       the 'split function' mapping the elements of this list to an scala.util.Either

     returns

       a pair of lists: the first one made of those values returned by `f` that were wrapped in scala.util.Left, and the second one made of those wrapped in scala.util.Right.

     Definition Classes
       StrictOptimizedIterableOps → IterableOps
126.  def patch[B >: Nothing](from: Int, other: IterableOnce[B], replaced: Int): List[B]

     Produces a new list where a slice of elements in this list is replaced by another sequence.

     Produces a new list where a slice of elements in this list is replaced by another sequence.

     Patching at negative indices is the same as patching starting at 0. Patching at indices at or larger than the length of the original list appends the patch to the end. If more values are replaced than actually exist, the excess is ignored.

     B

       the element type of the returned list.

     from

       the index of the first replaced element

     other

       the replacement sequence

     replaced

       the number of elements to drop in the original list

     returns

       a new list consisting of all elements of this list except that `replaced` elements starting from `from` are replaced by all the elements of `other`.

     Definition Classes
       StrictOptimizedSeqOps → SeqOps
127.  def permutations: Iterator[List[Nothing]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     Note: Even when applied to a view or a lazy collection it will always force the elements.

     returns

       An Iterator which traverses the distinct permutations of this list.

     Definition Classes
       SeqOps
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

128.  def prepended[B >: Nothing](elem: B): List[B]

     A copy of the list with an element prepended.

     A copy of the list with an element prepended.

     Also, the original list is not modified, so you will want to capture the result.

     Example:

         scala> val x = List(1)
         x: List[Int] = List(1)

         scala> val y = 2 +: x
         y: List[Int] = List(2, 1)

         scala> println(x)
         List(1)

     B

       the element type of the returned list.

     elem

       the prepended element

     returns

       a new list consisting of `value` followed by all elements of this list.

     Definition Classes
       List → StrictOptimizedSeqOps → SeqOps
129.  def prependedAll[B >: Nothing](prefix: IterableOnce[B]): List[B]

     As with `:++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

     As with `:++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

     It differs from `:++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

     B

       the element type of the returned collection.

     prefix

       the iterable to prepend.

     returns

       a new list which contains all elements of `prefix` followed by all the elements of this list.

     Definition Classes
       List → StrictOptimizedSeqOps → SeqOps
130.  def product[B >: Nothing](implicit num: math.Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this list with respect to the `*` operator in `num`.

     Definition Classes
       IterableOnceOps
131.  def productElementName(n: Int): String

     The name of the nth element of this product, 0-based.

     The name of the nth element of this product, 0-based. In the default implementation, an empty string.

     n

       the index of the element name to return

     returns

       the name of the specified element

     Definition Classes
       Product
     Exceptions thrown

       `IndexOutOfBoundsException` if the `n` is out of range(n < 0 || n >= productArity).

132.  def productElementNames: scala.Iterator[String]

     An iterator over the names of all the elements of this product.

     An iterator over the names of all the elements of this product.

     Definition Classes
       Product
133.  def reduce[B >: Nothing](op: (B, B) => B): B

     Reduces the elements of this list using the specified associative binary operator.

     Reduces the elements of this list using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     B

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the list is nonempty.

     Definition Classes
       IterableOnceOps
     Exceptions thrown

       `UnsupportedOperationException` if this list is empty.

134.  def reduceLeft[B >: Nothing](op: (B, Nothing) => B): B

     Applies a binary operator to all elements of this list, going left to right.

     Applies a binary operator to all elements of this list, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this list, going left to right: `op( op( ... op(x1, x2) ..., xn-1), xn)` where `x1, ..., xn` are the elements of this list.

     Definition Classes
       IterableOnceOps
     Exceptions thrown

       `UnsupportedOperationException` if this list is empty.

135.  def reduceLeftOption[B >: Nothing](op: (B, Nothing) => B): Option[B]

     Optionally applies a binary operator to all elements of this list, going left to right.

     Optionally applies a binary operator to all elements of this list, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` if this list is nonempty, `None` otherwise.

     Definition Classes
       IterableOnceOps
136.  def reduceOption[B >: Nothing](op: (B, B) => B): Option[B]

     Reduces the elements of this list, if any, using the specified associative binary operator.

     Reduces the elements of this list, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     B

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       IterableOnceOps
137.  def reduceRight[B >: Nothing](op: (Nothing, B) => B): B

     Applies a binary operator to all elements of this list, going right to left.

     Applies a binary operator to all elements of this list, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this list, going right to left: `op(x1, op(x2, ..., op(xn-1, xn)...))` where `x1, ..., xn` are the elements of this list.

     Definition Classes
       IterableOnceOps
     Exceptions thrown

       `UnsupportedOperationException` if this list is empty.

138.  def reduceRightOption[B >: Nothing](op: (Nothing, B) => B): Option[B]

     Optionally applies a binary operator to all elements of this list, going right to left.

     Optionally applies a binary operator to all elements of this list, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` if this list is nonempty, `None` otherwise.

     Definition Classes
       IterableOnceOps
139.  final def reverse: List[Nothing]

     Returns new list with elements in reversed order.

     Returns new list with elements in reversed order.

     Note: Even when applied to a view or a lazy collection it will always force the elements.

     returns

       A new list with all elements of this list in reversed order.

     Definition Classes
       List → SeqOps
140.  def reverseIterator: Iterator[Nothing]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this list in reversed order

     Definition Classes
       SeqOps
141.  def reverse_:::[B >: Nothing](prefix: List[B]): List[B]

     Adds the elements of a given list in reverse order in front of this list.

     Adds the elements of a given list in reverse order in front of this list. `xs reverse_::: ys` is equivalent to `xs.reverse ::: ys` but is more efficient.

     prefix

       the prefix to reverse and then prepend

     returns

       the concatenation of the reversed prefix and the current list.

     Definition Classes
       List
142.  def reversed: collection.Iterable[Nothing]
     Attributes
       protected
     Definition Classes
       IterableOnceOps
143.  def runWith[U](action: (Nothing) => U): (Int) => Boolean

     Composes this partial function with an action function which gets applied to results of this partial function.

     Composes this partial function with an action function which gets applied to results of this partial function. The action function is invoked only for its side effects; its result is ignored.

     Note that expression `pf.runWith(action)(x)` is equivalent to

         if(pf isDefinedAt x) { action(pf(x)); true } else false

     except that `runWith` is implemented via `applyOrElse` and thus potentially more efficient. Using `runWith` avoids double evaluation of pattern matchers and guards for partial function literals.

     action

       the action function

     returns

       a function which maps arguments `x` to `isDefinedAt(x)`. The resulting function runs `action(this(x))` where `this` is defined.

     Definition Classes
       PartialFunction
     See also

       `applyOrElse`.

144.  def sameElements[B >: Nothing](that: IterableOnce[B]): Boolean

     Are the elements of this collection the same (and in the same order) as those of `that`?

     Are the elements of this collection the same (and in the same order) as those of `that`?

     Definition Classes
       LinearSeqOps → SeqOps
145.  def scan[B >: Nothing](z: B)(op: (B, B) => B): List[B]

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     returns

       a new list containing the prefix scan of the elements in this list

     Definition Classes
       IterableOps
146.  def scanLeft[B](z: B)(op: (B, Nothing) => B): List[B]

     Produces a list containing cumulative results of applying the operator going left to right, including the initial value.

     Produces a list containing cumulative results of applying the operator going left to right, including the initial value.

     B

       the type of the elements in the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     returns

       collection with intermediate results

     Definition Classes
       StrictOptimizedIterableOps → IterableOps → IterableOnceOps
147.  def scanRight[B](z: B)(op: (Nothing, B) => B): List[B]

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Note: Even when applied to a view or a lazy collection it will always force the elements.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     returns

       collection with intermediate results

     Definition Classes
       IterableOps
148.  def search[B >: Nothing](elem: B, from: Int, to: Int)(implicit ord: Ordering[B]): SearchResult

     Search within an interval in this sorted sequence for a specific element.

     Search within an interval in this sorted sequence for a specific element. If this sequence is an `IndexedSeq`, a binary search is used. Otherwise, a linear search is used.

     The sequence should be sorted with the same `Ordering` before calling; otherwise, the results are undefined.

     elem

       the element to find.

     from

       the index where the search starts.

     to

       the index following where the search ends.

     ord

       the ordering to be used to compare elements.

     returns

       a `Found` value containing the index corresponding to the element in the sequence, or the `InsertionPoint` where the element would be inserted if the element is not in the sequence.

     Definition Classes
       SeqOps
     Note

       if `to <= from`, the search space is empty, and an `InsertionPoint` at `from` is returned

     See also

       scala.collection.IndexedSeq

       scala.math.Ordering

       scala.collection.SeqOps, method `sorted`

149.  def search[B >: Nothing](elem: B)(implicit ord: Ordering[B]): SearchResult

     Search this sorted sequence for a specific element.

     Search this sorted sequence for a specific element. If the sequence is an `IndexedSeq`, a binary search is used. Otherwise, a linear search is used.

     The sequence should be sorted with the same `Ordering` before calling; otherwise, the results are undefined.

     elem

       the element to find.

     ord

       the ordering to be used to compare elements.

     returns

       a `Found` value containing the index corresponding to the element in the sequence, or the `InsertionPoint` where the element would be inserted if the element is not in the sequence.

     Definition Classes
       SeqOps
     See also

       scala.collection.IndexedSeq

       scala.math.Ordering

       scala.collection.SeqOps, method `sorted`

150.  def segmentLength(p: (Nothing) => Boolean, from: Int): Int

     Computes the length of the longest segment that starts from some index and whose elements all satisfy some predicate.

     Computes the length of the longest segment that starts from some index and whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this list starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       LinearSeqOps → SeqOps
151.  final def segmentLength(p: (Nothing) => Boolean): Int

     Computes the length of the longest segment that starts from the first element and whose elements all satisfy some predicate.

     Computes the length of the longest segment that starts from the first element and whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest segment of this list that starts from the first element such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqOps
152.  final def size: Int

     The size of this list.

     The size of this list.

     returns

       the number of elements in this list.

     Definition Classes
       SeqOps → IterableOnceOps
153.  final def sizeCompare(that: collection.Iterable[_]): Int

     Compares the size of this list to the size of another `Iterable`.

     Compares the size of this list to the size of another `Iterable`.

     that

       the `Iterable` whose size is compared with this list's size.

     returns

       A value `x` where

           x <  0       if this.size <  that.size
           x == 0       if this.size == that.size
           x >  0       if this.size >  that.size

       The method as implemented here does not call `size` directly; its running time is `O(this.size min that.size)` instead of `O(this.size + that.size)`. The method should be overridden if computing `size` is cheap and `knownSize` returns `-1`.

     Definition Classes
       SeqOps → IterableOps
154.  final def sizeCompare(otherSize: Int): Int

     Compares the size of this list to a test value.

     Compares the size of this list to a test value.

     otherSize

       the test value that gets compared with the size.

     returns

       A value `x` where

           x <  0       if this.size <  otherSize
           x == 0       if this.size == otherSize
           x >  0       if this.size >  otherSize

       The method as implemented here does not call `size` directly; its running time is `O(size min otherSize)` instead of `O(size)`. The method should be overridden if computing `size` is cheap and `knownSize` returns `-1`.

     Definition Classes
       SeqOps → IterableOps
     See also

       sizeIs

155.  final def sizeIs: SizeCompareOps

     Returns a value class containing operations for comparing the size of this list to a test value.

     Returns a value class containing operations for comparing the size of this list to a test value.

     These operations are implemented in terms of `sizeCompare(Int)`, and allow the following more readable usages:

         this.sizeIs < size     // this.sizeCompare(size) < 0
         this.sizeIs <= size    // this.sizeCompare(size) <= 0
         this.sizeIs == size    // this.sizeCompare(size) == 0
         this.sizeIs != size    // this.sizeCompare(size) != 0
         this.sizeIs >= size    // this.sizeCompare(size) >= 0
         this.sizeIs > size     // this.sizeCompare(size) > 0

     Definition Classes
       IterableOps
     Annotations
       @inline()
156.  def slice(from: Int, until: Int): List[Nothing]

     from

       the lowest index to include from this list.

     until

       the lowest index to EXCLUDE from this list.

     returns

       a list containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this list.

     Definition Classes
       List → IterableOps → IterableOnceOps
     Example:

     1.     // Given a list
            val letters = List('a','b','c','d','e')

            // `slice` returns all elements beginning at index `from` and afterwards,
            // up until index `until` (excluding index `until`.)
            letters.slice(1,3) // Returns List('b','c')

157.  def sliding(size: Int, step: Int): Iterator[List[Nothing]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     The returned iterator will be empty when called on an empty collection. The last element the iterator produces may be smaller than the window size when the original collection isn't exhausted by the window before it and its last element isn't skipped by the step before it.

     size

       the number of elements per group

     step

       the distance between the first elements of successive groups

     returns

       An iterator producing lists of size `size`, except the last element (which may be the only element) will be smaller if there are fewer than `size` elements remaining to be grouped.

     Definition Classes
       IterableOps
     Examples:

     1. `List(1, 2, 3, 4, 5).sliding(2, 2) = Iterator(List(1, 2), List(3, 4), List(5))`

     ,

     2. `List(1, 2, 3, 4, 5, 6).sliding(2, 3) = Iterator(List(1, 2), List(4, 5))`

     See also

       scala.collection.Iterator, method `sliding`

158.  def sliding(size: Int): Iterator[List[Nothing]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in `grouped`.)

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in `grouped`.)

     An empty collection returns an empty iterator, and a non-empty collection containing fewer elements than the window size returns an iterator that will produce the original collection as its only element.

     size

       the number of elements per group

     returns

       An iterator producing lists of size `size`, except for a non-empty collection with less than `size` elements, which returns an iterator that produces the source collection itself as its only element.

     Definition Classes
       IterableOps
     Examples:

     1. `List().sliding(2) = empty iterator`

     ,

     2. `List(1).sliding(2) = Iterator(List(1))`

     ,

     3. `List(1, 2).sliding(2) = Iterator(List(1, 2))`

     ,

     4. `List(1, 2, 3).sliding(2) = Iterator(List(1, 2), List(2, 3))`

     See also

       scala.collection.Iterator, method `sliding`

159.  def sortBy[B](f: (Nothing) => B)(implicit ord: Ordering[B]): List[Nothing]

     Sorts this list according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this list according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Note: Even when applied to a view or a lazy collection it will always force the elements.

     The sort is stable. That is, elements that are equal (as determined by `ord.compare`) appear in the same order in the sorted sequence as in the original.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a list consisting of the elements of this list sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqOps
     Example:

     1.     val words = "The quick brown fox jumped over the lazy dog".split(' ')
            // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
            words.sortBy(x => (x.length, x.head))
            res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

160.  def sortWith(lt: (Nothing, Nothing) => Boolean): List[Nothing]

     Sorts this list according to a comparison function.

     Sorts this list according to a comparison function.

     Note: Even when applied to a view or a lazy collection it will always force the elements.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a list consisting of the elements of this list sorted according to the comparison function `lt`.

     Definition Classes
       SeqOps
     Example:

     1.     List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
            List("Bob", "John", "Steve", "Tom")

161.  def sorted[B >: Nothing](implicit ord: Ordering[B]): List[Nothing]

     Sorts this list according to an Ordering.

     Sorts this list according to an Ordering.

     The sort is stable. That is, elements that are equal (as determined by `ord.compare`) appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a list consisting of the elements of this list sorted according to the ordering `ord`.

     Definition Classes
       StrictOptimizedSeqOps → SeqOps
     See also

       scala.math.Ordering Note: Even when applied to a view or a lazy collection it will always force the elements.

162.  final def span(p: (Nothing) => Boolean): (List[Nothing], List[Nothing])

     Splits this list into a prefix/suffix pair according to a predicate.

     Splits this list into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this list whose elements all satisfy `p`, and the rest of this list.

     Definition Classes
       List → StrictOptimizedIterableOps → IterableOps → IterableOnceOps
     Annotations
       @inline()
163.  def splitAt(n: Int): (List[Nothing], List[Nothing])

     Splits this list into a prefix/suffix pair at a given position.

     Splits this list into a prefix/suffix pair at a given position.

     Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of lists consisting of the first `n` elements of this list, and the other elements.

     Definition Classes
       List → IterableOps → IterableOnceOps
164.  def startsWith[B >: Nothing](that: IterableOnce[B], offset: Int = 0): Boolean

     Tests whether this list contains the given sequence at a given index.

     Tests whether this list contains the given sequence at a given index.

     Note: If the both the receiver object `this` and the argument `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this list at index `offset`, otherwise `false`.

     Definition Classes
       SeqOps
165.  def stepper[S <: Stepper[_]](implicit shape: StepperShape[Nothing, S]): S

     Returns a scala.collection.Stepper for the elements of this collection.

     Returns a scala.collection.Stepper for the elements of this collection.

     The Stepper enables creating a Java stream to operate on the collection, see scala.jdk.StreamConverters. For collections holding primitive values, the Stepper can be used as an iterator which doesn't box the elements.

     The implicit scala.collection.StepperShape parameter defines the resulting Stepper type according to the element type of this collection.

     - For collections of `Int`, `Short`, `Byte` or `Char`, an scala.collection.IntStepper is returned
     - For collections of `Double` or `Float`, a scala.collection.DoubleStepper is returned
     - For collections of `Long` a scala.collection.LongStepper is returned
     - For any other element type, an scala.collection.AnyStepper is returned

     Note that this method is overridden in subclasses and the return type is refined to `S with EfficientSplit`, for example scala.collection.IndexedSeqOps.stepper. For Steppers marked with scala.collection.Stepper.EfficientSplit, the converters in scala.jdk.StreamConverters allow creating parallel streams, whereas bare Steppers can be converted only to sequential streams.

     Definition Classes
       IterableOnce
166.  final def strictOptimizedCollect[B, C2](b: Builder[B, C2], pf: PartialFunction[Nothing, B]): C2

     B

       Type of elements of the resulting collection (e.g. `String`)

     C2

       Type of the resulting collection (e.g. `List[String]`)

     b

       Builder to use to build the resulting collection

     pf

       Element transformation partial function

     returns

       The resulting collection

     Attributes
       protected[this]
     Definition Classes
       StrictOptimizedIterableOps
     Annotations
       @inline()
167.  final def strictOptimizedConcat[B >: Nothing, C2](that: IterableOnce[B], b: Builder[B, C2]): C2

     B

       Type of elements of the resulting collections (e.g. `Int`)

     C2

       Type of the resulting collection (e.g. `List[Int]`)

     that

       Elements to concatenate to this collection

     b

       Builder to use to build the resulting collection

     returns

       The resulting collection

     Attributes
       protected[this]
     Definition Classes
       StrictOptimizedIterableOps
     Annotations
       @inline()
168.  final def strictOptimizedFlatMap[B, C2](b: Builder[B, C2], f: (Nothing) => IterableOnce[B]): C2

     B

       Type of elements of the resulting collection (e.g. `String`)

     C2

       Type of the resulting collection (e.g. `List[String]`)

     b

       Builder to use to build the resulting collection

     f

       Element transformation function

     returns

       The resulting collection

     Attributes
       protected[this]
     Definition Classes
       StrictOptimizedIterableOps
     Annotations
       @inline()
169.  final def strictOptimizedFlatten[B, C2](b: Builder[B, C2])(implicit toIterableOnce: (Nothing) => IterableOnce[B]): C2

     B

       Type of elements of the resulting collection (e.g. `Int`)

     C2

       Type of the resulting collection (e.g. `List[Int]`)

     b

       Builder to use to build the resulting collection

     toIterableOnce

       Evidence that `A` can be seen as an `IterableOnce[B]`

     returns

       The resulting collection

     Attributes
       protected[this]
     Definition Classes
       StrictOptimizedIterableOps
     Annotations
       @inline()
170.  final def strictOptimizedMap[B, C2](b: Builder[B, C2], f: (Nothing) => B): C2

     B

       Type of elements of the resulting collection (e.g. `String`)

     C2

       Type of the resulting collection (e.g. `List[String]`)

     b

       Builder to use to build the resulting collection

     f

       Element transformation function

     returns

       The resulting collection

     Attributes
       protected[this]
     Definition Classes
       StrictOptimizedIterableOps
     Annotations
       @inline()
171.  final def strictOptimizedZip[B, C2](that: IterableOnce[B], b: Builder[(Nothing, B), C2]): C2

     B

       Type of elements of the second collection (e.g. `String`)

     C2

       Type of the resulting collection (e.g. `List[(Int, String)]`)

     that

       Collection to zip with this collection

     b

       Builder to use to build the resulting collection

     returns

       The resulting collection

     Attributes
       protected[this]
     Definition Classes
       StrictOptimizedIterableOps
     Annotations
       @inline()
172.  def stringPrefix: String
     Attributes
       protected[this]
     Definition Classes
       LinearSeq → Seq → Iterable
     Annotations
       @nowarn()
173.  def sum[B >: Nothing](implicit num: math.Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this list with respect to the `+` operator in `num`.

     Definition Classes
       IterableOnceOps
174.  final def synchronized[T0](arg0: => T0): T0

     Executes the code in `body` with an exclusive lock on `this`.

     Executes the code in `body` with an exclusive lock on `this`.

     returns

       the result of `body`

     Definition Classes
       AnyRef
175.  def tail: Nothing

     The rest of the collection without its first element.

     The rest of the collection without its first element.

     Definition Classes
       Nil → LinearSeqOps → IterableOps
176.  def tails: Iterator[List[Nothing]]

     Iterates over the tails of this list.

     Iterates over the tails of this list. The first value will be this list and the final one will be an empty list, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this list

     Definition Classes
       LinearSeqOps → IterableOps
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

177.  def take(n: Int): List[Nothing]

     Selects the first n elements.

     Selects the first n elements.

     n

       the number of elements to take from this list.

     returns

       a list consisting only of the first `n` elements of this list, or else the whole list, if it has less than `n` elements. If `n` is negative, returns an empty list.

     Definition Classes
       List → IterableOps → IterableOnceOps
178.  def takeRight(n: Int): List[Nothing]

     A collection containing the last `n` elements of this collection.

     A collection containing the last `n` elements of this collection.

     Note: Even when applied to a view or a lazy collection it will always force the elements.

     n

       the number of elements to take from this list.

     returns

       a list consisting only of the last `n` elements of this list, or else the whole list, if it has less than `n` elements. If `n` is negative, returns an empty list.

     Definition Classes
       List → StrictOptimizedIterableOps → IterableOps
179.  final def takeWhile(p: (Nothing) => Boolean): List[Nothing]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this list whose elements all satisfy the predicate `p`.

     Definition Classes
       List → IterableOps → IterableOnceOps
     Annotations
       @inline()
180.  def tapEach[U](f: (Nothing) => U): List[Nothing]

     Applies a side-effecting function to each element in this collection.

     Applies a side-effecting function to each element in this collection. Strict collections will apply `f` to their elements immediately, while lazy collections like Views and LazyLists will only apply `f` on each element if and when that element is evaluated, and each time that element is evaluated.

     U

       the return type of f

     f

       a function to apply to each element in this list

     returns

       The same logical collection as this

     Definition Classes
       StrictOptimizedIterableOps → IterableOps → IterableOnceOps
181.  def to[C1](factory: Factory[Nothing, C1]): C1

     Given a collection factory `factory`, convert this collection to the appropriate representation for the current element type `A`.

     Given a collection factory `factory`, convert this collection to the appropriate representation for the current element type `A`. Example uses:

     xs.to(List) xs.to(ArrayBuffer) xs.to(BitSet) // for xs: Iterable[Int]

     Definition Classes
       IterableOnceOps
182.  def toArray[B >: Nothing](implicit arg0: ClassTag[B]): Array[B]

     Convert collection to array.

     Convert collection to array.

     Implementation note: DO NOT call Array.from from this method.

     Definition Classes
       IterableOnceOps
183.  final def toBuffer[B >: Nothing]: Buffer[B]
     Definition Classes
       IterableOnceOps
     Annotations
       @inline()
184.  def toIndexedSeq: IndexedSeq[Nothing]
     Definition Classes
       IterableOnceOps
185.  final def toIterable: Nil.this.type

     returns

       This collection as an `Iterable[A]`. No new collection will be built if `this` is already an `Iterable[A]`.

     Definition Classes
       Iterable → IterableOps
186.  final def toList: List[Nothing]
     Definition Classes
       List → IterableOnceOps
187.  def toMap[K, V](implicit ev: <:<[Nothing, (K, V)]): Map[K, V]
     Definition Classes
       IterableOnceOps
188.  final def toSeq: Nil.this.type

     returns

       This collection as a `Seq[A]`. This is equivalent to `to(Seq)` but might be faster.

     Definition Classes
       Seq → IterableOnceOps
189.  def toSet[B >: Nothing]: Set[B]
     Definition Classes
       IterableOnceOps
190.  def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       Seq → Function1 → Iterable → AnyRef → Any
191.  def toVector: Vector[Nothing]
     Definition Classes
       IterableOnceOps
192.  def transpose[B](implicit asIterable: (Nothing) => collection.Iterable[B]): List[List[B]]

     Transposes this list of iterable collections into a list of lists.

     Transposes this list of iterable collections into a list of lists.

     The resulting collection's type will be guided by the static type of list. For example:

         val xs = List(
                    Set(1, 2, 3),
                    Set(4, 5, 6)).transpose
         // xs == List(
         //         List(1, 4),
         //         List(2, 5),
         //         List(3, 6))

         val ys = Vector(
                    List(1, 2, 3),
                    List(4, 5, 6)).transpose
         // ys == Vector(
         //         Vector(1, 4),
         //         Vector(2, 5),
         //         Vector(3, 6))

     Note: Even when applied to a view or a lazy collection it will always force the elements.

     B

       the type of the elements of each iterable collection.

     asIterable

       an implicit conversion which asserts that the element type of this list is an `Iterable`.

     returns

       a two-dimensional list of lists which has as nth row the nth column of this list.

     Definition Classes
       IterableOps
     Exceptions thrown

       `IllegalArgumentException` if all collections in this list are not of the same size.

193.  def unapply(a: Int): Option[Nothing]

     Tries to extract a `B` from an `A` in a pattern matching expression.

     Tries to extract a `B` from an `A` in a pattern matching expression.

     Definition Classes
       PartialFunction
194.  def unzip[A1, A2](implicit asPair: (Nothing) => (A1, A2)): (List[A1], List[A2])

     Converts this list of pairs into two collections of the first and second half of each pair.

     Converts this list of pairs into two collections of the first and second half of each pair.

         val xs = `List`(
                    (1, "one"),
                    (2, "two"),
                    (3, "three")).unzip
         // xs == (`List`(1, 2, 3),
         //        `List`(one, two, three))

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this list is a pair.

     returns

       a pair of lists, containing the first, respectively second half of each element pair of this list.

     Definition Classes
       Nil → StrictOptimizedIterableOps → IterableOps
195.  def unzip3[A1, A2, A3](implicit asTriple: (Nothing) => (A1, A2, A3)): (List[A1], List[A2], List[A3])

     Converts this list of triples into three collections of the first, second, and third element of each triple.

     Converts this list of triples into three collections of the first, second, and third element of each triple.

         val xs = `List`(
                    (1, "one", '1'),
                    (2, "two", '2'),
                    (3, "three", '3')).unzip3
         // xs == (`List`(1, 2, 3),
         //        `List`(one, two, three),
         //        `List`(1, 2, 3))

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this list is a triple.

     returns

       a triple of lists, containing the first, second, respectively third member of each element triple of this list.

     Definition Classes
       StrictOptimizedIterableOps → IterableOps
196.  def updated[B >: Nothing](index: Int, elem: B): List[B]

     A copy of this list with one single replaced element.

     A copy of this list with one single replaced element.

     B

       the element type of the returned list.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new list which is a copy of this list with the element at position `index` replaced by `elem`.

     Definition Classes
       List → StrictOptimizedSeqOps → SeqOps
     Exceptions thrown

       `IndexOutOfBoundsException` if `index` does not satisfy `0 <= index < length`. In case of a lazy collection this exception may be thrown at a later time or not at all (if the end of the collection is never evaluated).

197.  def view: SeqView[Nothing]

     A view over the elements of this collection.

     A view over the elements of this collection.

     Definition Classes
       SeqOps → IterableOps
198.  final def wait(): Unit

     See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

     See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
     Note

       not specified by SLS as a member of AnyRef

199.  final def wait(arg0: Long, arg1: Int): Unit

     See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

     See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
     Note

       not specified by SLS as a member of AnyRef

200.  final def wait(arg0: Long): Unit

     See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

     See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException]) @native()
     Note

       not specified by SLS as a member of AnyRef

201.  def withFilter(p: (Nothing) => Boolean): WithFilter[Nothing, [_]List[_]]

     Creates a non-strict filter of this list.

     Creates a non-strict filter of this list.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this list which satisfy the predicate `p`.

     Definition Classes
       IterableOps
202.  def writeReplace(): AnyRef
     Attributes
       protected[this]
     Definition Classes
       DefaultSerializable
203.  def zip[B](that: IterableOnce[B]): List[(Nothing, B)]

     Returns a list formed from this list and another iterable collection by combining corresponding elements in pairs.

     Returns a list formed from this list and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new list containing pairs consisting of corresponding elements of this list and `that`. The length of the returned collection is the minimum of the lengths of this list and `that`.

     Definition Classes
       StrictOptimizedIterableOps → IterableOps
204.  def zipAll[A1 >: Nothing, B](that: collection.Iterable[B], thisElem: A1, thatElem: B): List[(A1, B)]

     Returns a list formed from this list and another iterable collection by combining corresponding elements in pairs.

     Returns a list formed from this list and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this list is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this list.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this list and `that`. The length of the returned collection is the maximum of the lengths of this list and `that`. If this list is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this list, `thatElem` values are used to pad the result.

     Definition Classes
       IterableOps
205.  def zipWithIndex: List[(Nothing, Int)]

     Zips this list with its indices.

     Zips this list with its indices.

     returns

       A new list containing pairs consisting of all elements of this list paired with their index. Indices start at `0`.

     Definition Classes
       StrictOptimizedIterableOps → IterableOps → IterableOnceOps
     Example:

     1. `List("a", "b", "c").zipWithIndex == List(("a", 0), ("b", 1), ("c", 2))`

### Deprecated Value Members

1.  final def /:[B](z: B)(op: (B, Nothing) => B): B
   Definition Classes
     IterableOnceOps
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use foldLeft instead of /:

2.  final def :\[B](z: B)(op: (Nothing, B) => B): B
   Definition Classes
     IterableOnceOps
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use foldRight instead of :\

3.  def aggregate[B](z: => B)(seqop: (B, Nothing) => B, combop: (B, B) => B): B
   Definition Classes
     IterableOnceOps
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) `aggregate` is not relevant for sequential collections. Use `foldLeft(z)(seqop)` instead.

4.  def companion: IterableFactory[[_]List[_]]
   Definition Classes
     IterableOps
   Annotations
     @deprecated @deprecatedOverriding(message = "Use iterableFactory instead", since = "2.13.0") @inline()
   Deprecated

     (Since version 2.13.0) Use iterableFactory instead

5.  final def copyToBuffer[B >: Nothing](dest: Buffer[B]): Unit
   Definition Classes
     IterableOnceOps
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use `dest ++= coll` instead

6.  def hasDefiniteSize: Boolean

   Tests whether this list is known to have a finite size.

   Tests whether this list is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end. Non-empty Iterators usually return `false` even if they were created from a collection with a known finite size.

   Note: many collection methods will not work on collections of infinite sizes. The typical failure mode is an infinite loop. These methods always attempt a traversal without checking first that `hasDefiniteSize` returns `true`. However, checking `hasDefiniteSize` can provide an assurance that size is well-defined and non-termination is not a concern.

   returns

     `true` if this collection is known to have finite size, `false` otherwise.

   Definition Classes
     IterableOnceOps
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Check .knownSize instead of .hasDefiniteSize for more actionable information (see scaladoc for details)

   See also

     method `knownSize` for a more useful alternative

7.  final def prefixLength(p: (Nothing) => Boolean): Int

   Returns the length of the longest prefix whose elements all satisfy some predicate.

   Returns the length of the longest prefix whose elements all satisfy some predicate.

   p

     the predicate used to test elements.

   returns

     the length of the longest prefix of this list such that every element of the segment satisfies the predicate `p`.

   Definition Classes
     SeqOps
   Annotations
     @deprecated @inline()
   Deprecated

     (Since version 2.13.0) Use segmentLength instead of prefixLength

8.  final def repr: List[Nothing]
   Definition Classes
     IterableOps
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use coll instead of repr in a collection implementation, use the collection value itself from the outside

9.  def reverseMap[B](f: (Nothing) => B): List[B]
   Definition Classes
     SeqOps
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use .reverseIterator.map(f).to(...) instead of .reverseMap(f)

10.  def seq: Nil.this.type
    Definition Classes
      Iterable
    Annotations
      @deprecated
    Deprecated

      (Since version 2.13.0) Iterable.seq always returns the iterable itself

11.  final def toIterator: Iterator[Nothing]
    Definition Classes
      IterableOnceOps
    Annotations
      @deprecated @inline()
    Deprecated

      (Since version 2.13.0) Use .iterator instead of .toIterator

12.  final def toStream: Stream[Nothing]
    Definition Classes
      IterableOnceOps
    Annotations
      @deprecated @inline()
    Deprecated

      (Since version 2.13.0) Use .to(LazyList) instead of .toStream

13.  final def toTraversable: collection.Traversable[Nothing]

    Converts this list to an unspecified Iterable.

    Converts this list to an unspecified Iterable. Will return the same collection if this instance is already Iterable.

    returns

      An Iterable containing all elements of this list.

    Definition Classes
      IterableOps
    Annotations
      @deprecated
    Deprecated

      (Since version 2.13.0) Use toIterable instead

14.  final def union[B >: Nothing](that: collection.Seq[B]): List[B]

    Produces a new sequence which contains all elements of this list and also all elements of a given sequence.

    Produces a new sequence which contains all elements of this list and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

    B

      the element type of the returned list.

    that

      the sequence to add.

    returns

      a new collection which contains all elements of this list followed by all elements of `that`.

    Definition Classes
      SeqOps
    Annotations
      @deprecated @inline()
    Deprecated

      (Since version 2.13.0) Use `concat` instead

15.  def view(from: Int, until: Int): View[Nothing]

    A view over a slice of the elements of this collection.

    A view over a slice of the elements of this collection.

    Definition Classes
      IterableOps
    Annotations
      @deprecated
    Deprecated

      (Since version 2.13.0) Use .view.slice(from, until) instead of .view(from, until)

### Inherited from Product

### Inherited from List[Nothing]

### Inherited from DefaultSerializable

### Inherited from java.io.Serializable

### Inherited from StrictOptimizedSeqOps[Nothing, List, List[Nothing]]

### Inherited from StrictOptimizedLinearSeqOps[Nothing, List, List[Nothing]]

### Inherited from collection.StrictOptimizedSeqOps[Nothing, List, List[Nothing]]

### Inherited from StrictOptimizedIterableOps[Nothing, List, List[Nothing]]

### Inherited from LinearSeq[Nothing]

### Inherited from LinearSeqOps[Nothing, [X]List[X], List[Nothing]]

### Inherited from collection.LinearSeq[Nothing]

### Inherited from collection.LinearSeqOps[Nothing, [X]List[X], List[Nothing]]

### Inherited from AbstractSeq[Nothing]

### Inherited from Seq[Nothing]

### Inherited from SeqOps[Nothing, [_]List[_], List[Nothing]]

### Inherited from Iterable[Nothing]

### Inherited from collection.AbstractSeq[Nothing]

### Inherited from collection.Seq[Nothing]

### Inherited from Equals

### Inherited from collection.SeqOps[Nothing, [_]List[_], List[Nothing]]

### Inherited from PartialFunction[Int, Nothing]

### Inherited from (Int) => Nothing

### Inherited from AbstractIterable[Nothing]

### Inherited from collection.Iterable[Nothing]

### Inherited from IterableFactoryDefaults[Nothing, [x]List[x]]

### Inherited from IterableOps[Nothing, [_]List[_], List[Nothing]]

### Inherited from IterableOnceOps[Nothing, [_]List[_], List[Nothing]]

### Inherited from IterableOnce[Nothing]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped